package wcst.transaction.tools;

//~--- non-JDK imports --------------------------------------------------------

import org.odmg.*;

import rasj.*;

import wcst.transaction.executeTransaction.ShowImage;

//~--- JDK imports ------------------------------------------------------------

import java.awt.Graphics;

import java.awt.image.BufferedImage;

import java.io.IOException;

import java.net.URL;

import javax.imageio.ImageIO;

import javax.swing.JFrame;

/**
 * @author Andrei Aiordachioaie
 */
public class TestRasdamanBug
{
	private static RasdamanUtils myUtils;

	public static void main(String[] args)
			throws ODMGException, RasResultIsNoIntervalException, IOException, Exception
	{
		try
		{
			myUtils.commitAndClose();
			myUtils = new RasdamanUtils("http://kahlua.eecs.jacobs-university.de" + ":7001",
										"RASBASE");

			myUtils.init();

			insertImageFromInternet(
				"andreiFlickr1", "http://farm4.static.flickr.com/3347/3500129555_137c537e75_m.jpg");

			updateImageFromInternet("andreiFlickr1", "http://localhost/peta/car.jpeg");
		}
		catch (Exception e)
		{
			e.printStackTrace();
			myUtils.abortAndClose();
		}
	}

	private static void insertImageFromInternet(String identifier, String href)
	{
		try
		{
			// Step 1: fetch the image from Internet
			URL url = new URL(href);
			BufferedImage img0 = ImageIO.read(url);
			BufferedImage img = convertImageToGray(img0);

			// Display image for check
			displayImage(identifier, img);

			// Step 2: Insert image into rasdaman
			myUtils.insertGrayImageAsArray(identifier, img);
		}
		catch (Exception e)
		{
			System.err.println("Error: " + e.getMessage());
			e.printStackTrace();
		}
	}

	public static BufferedImage convertImageToGray(BufferedImage img)
	{
		BufferedImage image = new BufferedImage(img.getWidth(), img.getHeight(),
			BufferedImage.TYPE_BYTE_GRAY);
		Graphics g = image.getGraphics();

		g.drawImage(img, 0, 0, null);
		g.dispose();

		return image;
	}

	private static void updateImageFromInternet(String identifier, String href)
	{
		try
		{
			// Step 1: fetch the image from Internet
			URL url = new URL(href);
			BufferedImage img0 = ImageIO.read(url);
			BufferedImage img = myUtils.convertImageToGray(img0);

			// Display image for check
			displayImage(identifier, img);

			// Step 2: Update image into rasdaman
			myUtils.updateGrayImageWithArray(identifier, img, 0, 0, img.getWidth(),
											 img.getHeight());
		}
		catch (Exception e)
		{
			System.err.println("Error: " + e.getMessage());
			e.printStackTrace();
		}
	}

	public static void displayImage(String name, BufferedImage img)
	{
		JFrame f = new JFrame("Image " + name);

		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		f.getContentPane().add(new ShowImage(img));
		f.setSize(img.getWidth() + 50, img.getHeight() + 50);
		f.setVisible(true);
	}
}
